/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ContactStrictAttribute type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactStrictAttribute{}

// ContactStrictAttribute 
type ContactStrictAttribute struct {
	Type *string `json:"type,omitempty"`
	Value *ContactStrictAttributeValue `json:"value,omitempty"`
}

// NewContactStrictAttribute instantiates a new ContactStrictAttribute object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactStrictAttribute() *ContactStrictAttribute {
	this := ContactStrictAttribute{}
	return &this
}

// NewContactStrictAttributeWithDefaults instantiates a new ContactStrictAttribute object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactStrictAttributeWithDefaults() *ContactStrictAttribute {
	this := ContactStrictAttribute{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ContactStrictAttribute) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactStrictAttribute) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ContactStrictAttribute) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ContactStrictAttribute) SetType(v string) {
	o.Type = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *ContactStrictAttribute) GetValue() ContactStrictAttributeValue {
	if o == nil || IsNil(o.Value) {
		var ret ContactStrictAttributeValue
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactStrictAttribute) GetValueOk() (*ContactStrictAttributeValue, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *ContactStrictAttribute) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given ContactStrictAttributeValue and assigns it to the Value field.
func (o *ContactStrictAttribute) SetValue(v ContactStrictAttributeValue) {
	o.Value = &v
}

func (o ContactStrictAttribute) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactStrictAttribute) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	return toSerialize, nil
}

type NullableContactStrictAttribute struct {
	value *ContactStrictAttribute
	isSet bool
}

func (v NullableContactStrictAttribute) Get() *ContactStrictAttribute {
	return v.value
}

func (v *NullableContactStrictAttribute) Set(val *ContactStrictAttribute) {
	v.value = val
	v.isSet = true
}

func (v NullableContactStrictAttribute) IsSet() bool {
	return v.isSet
}

func (v *NullableContactStrictAttribute) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactStrictAttribute(val *ContactStrictAttribute) *NullableContactStrictAttribute {
	return &NullableContactStrictAttribute{value: val, isSet: true}
}

func (v NullableContactStrictAttribute) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactStrictAttribute) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


